fs = require('fs');

let output = {
    baseUrl: 'https://spwebapi.kramergroup.nl:8443/DpApp/',
    companycode: 'KRA',
    depotcode: '02',
    locations: [],
    groundLabelPlanes: [],
    statics: [
      {
        filename: 'assets/logo/kramer.glb',
        x: 3000,
        y: -3000,
        z: 350,
        rotation: 0,
        scale: 800
      }
    ]
    /* interval: 10000 */
};

let locations = [];

let bayWidth = 400;
let spacing = 40;
let height = 540;

//217
let stacks = [
    { stack: "217",
      start: 0,
      end: 50,
      anchorX: 3100,
      anchorY: -200,
      rotation: 95,
      depth: 560,
      capacity: 42,
      stackLabelOffsetX: 0,
      stackLabelOffsetY: 0,
      labelOffsetX: 400,
      labelOffsetY: 0

    },
    { stack: "218",
      start: 0,
      end: 60,
      anchorX: 10000,
      anchorY: 800,
      rotation: 95,
      depth: 480,
      capacity: 36,
      labelOffsetX: 350,
      labelOffsetY: 0
    },
    { stack: "219",
      start: 0,
      end: 99,
      anchorX: -1900,
      anchorY: 1000,
      rotation: 95,
      depth: 480,
      capacity: 36,
      labelOffsetX: 350,
      labelOffsetY: 0

    },
    { stack: "221",
      start: 0,
      end: 49,
      anchorX: -3000,
      anchorY: -2800,
      rotation: 0,
      depth: 240,
      capacity: 18,
      labelOffsetX: -250,
      labelOffsetY: 0

    },
    { stack: "222",
      start: 0,
      end: 25,
      anchorX: -4500,
      anchorY: -2200,
      rotation: 0,
      depth: 960,
      capacity: 72,
      labelOffsetX: 600,
      labelOffsetY: 0
    },
    { stack: "222",
      start: 27,
      end: 49,
      anchorX: -4500,
      anchorY: -5600,
      rotation: 0,
      depth: 960,
      capacity: 72,
      labelOffsetX: 600,
      labelOffsetY: 0
    },
    { stack: "223",
      start: 0,
      end: 25,
      anchorX: -5500,
      anchorY: -2200,
      rotation: 0,
      depth: 960,
      capacity: 72,
      labelOffsetX: -600,
      labelOffsetY: 0
    },
    { stack: "223",
      start: 27,
      end: 49,
      anchorX: -5500,
      anchorY: -5600,
      rotation: 0,
      depth: 960,
      capacity: 72,
      labelOffsetX: -600,
      labelOffsetY: 0
    },
    { stack: "224",
      start: 0,
      end: 25,
      anchorX: -7000,
      anchorY: -2200,
      rotation: 0,
      depth: 960,
      capacity: 72,
      labelOffsetX: 600,
      labelOffsetY: 0
    },
    { stack: "225",
      start: 0,
      end: 17,
      anchorX: -8000,
      anchorY: -2200,
      rotation: 0,
      depth: 800,
      capacity: 60,
      labelOffsetX: -500,
      labelOffsetY: 0
    },
    { stack: "226",
      start: 0,
      end: 17,
      anchorX: -9500,
      anchorY: -2000,
      rotation: 0,
      depth: 800,
      capacity: 60,
      labelOffsetX: 600,
      labelOffsetY: 0
    }
]

for (sc = 0; sc < stacks.length; sc++) {

    stack = stacks[sc];

    for (i = stack.start; i <= stack.end; i++) {
        let stackName = stack.stack;
        let locStr = i.toString();
        if (i < 10) {
            locStr = "0" + locStr;
        }
        let locationcode = stackName + "." + locStr;
        
        let x = 0;
        let y = 0 - ((i - stack.start) * ((bayWidth + spacing) / 4)) ;

        if (i % 2 !== 0) {
            width = bayWidth;
            //x = x - 1000;
        } else {
            width = bayWidth / 2;  
            //y = 400;
        }

        // Rotate
        let theta = stack.rotation * Math.PI / 180;
        let cs = Math.cos(theta);
        let sn = Math.sin(theta);

        let px = (x * cs) - (y * sn); 
        let py = (x * sn) + (y * cs);

        let location = {
            locationcode: locationcode,
            x: stack.anchorX + px,
            y: stack.anchorY + py,
            width: width,
            depth: stack.depth,
            height: height,
            capacity: stack.capacity,
            rotation: -stack.rotation, 
            type: 'heap'
        }

        locations.push(location);
    }
}

// Bay labels 
for (sc = 0; sc < stacks.length; sc++) {

  stack = stacks[sc];
  
  let x = stack.anchorX;
  let y = stack.anchorY;

  let offsetX = stack.labelOffsetX || 0;
  let offsetY = stack.labelOffsetY || 0;
 
  /* if (stack.labelOffsetX) {
    x = x + stack.labelOffsetX;
  }

  if (stack.labelOffsetY) {
    y = y + stack.labelOffsetY;
  } */

  // Rotate
  let theta = stack.rotation * Math.PI / 180;
  let cs = Math.cos(theta);
  let sn = Math.sin(theta);

  let px = (offsetX * cs) - (offsetY * sn); 
  let py = (offsetX * sn) + (offsetY * cs);

  let groundLabelPlane = {
    x: stack.anchorX + px, 
    y: stack.anchorY + py,
    rotation: -stack.rotation + 90, 
    labels: []
  }

  for (i = stack.start; i <= stack.end; i++) {
      
      let locStr = i.toString();
      if (i < 10) {
          locStr = "0" + locStr;
      }
      let locationcode = locStr;
      
      let x = 0 + ((i - stack.start)* ((bayWidth + spacing) / 4));
      let y = 40;

      if (i % 2 !== 0) {
          y = y + 40;
      } 

      let label = {
          text: locationcode,
          x: x,
          y: y,
      }

      groundLabelPlane.labels.push(label);
  }

  output.groundLabelPlanes.push(groundLabelPlane)
}

// Stack labels 
for (sc = 0; sc < stacks.length; sc++) {

  stack = stacks[sc];
  
  let x = stack.anchorX;
  let y = stack.anchorY;

  let offsetX = stack.StacklabelOffsetX || 0;
  let offsetY = stack.StacklabelOffsetY || 400;
 
  // Rotate
  let theta = stack.rotation * Math.PI / 180;
  let cs = Math.cos(theta);
  let sn = Math.sin(theta);

  let px = (offsetX * cs) - (offsetY * sn); 
  let py = (offsetX * sn) + (offsetY * cs);

  let groundLabelPlane = {
    x: stack.anchorX + px, 
    y: stack.anchorY + py,
    rotation: -stack.rotation + 90, 
    labels: []
  }

  let label = {
    text: stack.stack,
    x: 30,
    y: 40,
  }

  groundLabelPlane.labels.push(label);
  output.groundLabelPlanes.push(groundLabelPlane)
}

output.locations = locations;
output.groundPlanes = [
  { 
    // Water
    label: "",
    x: 8500,
    y: -5000,
    rotation: 0,
    width: 20000,
    height: 7000,
    // color: "#0a748a"
    color: "#363c5c"
  },
  // Gasvakken
  { 
    label: "Gasvak 2",
    x: -2200,
    y: -4100,
    rotation: -90,
    width: 2800,
    height: 1300,
    color: "#777777"
  },
  { 
    label: "Gasvak 1",
    x: -2200,
    y: -7000,
    rotation: -90,
    width: 2800,
    height: 1300,
    color: "#777777"
  }
  
] 

//console.log(output);


fs.writeFile('kramer.json', JSON.stringify(output), function (err) {
  if (err) return console.log(err);
});

